searchNodes=[{"doc":"Functions for converting data between Minizinc and Elixir.","ref":"MinizincData.html","title":"MinizincData","type":"module"},{"doc":"","ref":"MinizincData.html#dimensions/1","title":"MinizincData.dimensions/1","type":"function"},{"doc":"","ref":"MinizincData.html#elixir_to_dzn/1","title":"MinizincData.elixir_to_dzn/1","type":"function"},{"doc":"","ref":"MinizincData.html#make_dzn/2","title":"MinizincData.make_dzn/2","type":"function"},{"doc":"","ref":"MinizincData.html#output_to_elixir/1","title":"MinizincData.output_to_elixir/1","type":"function"},{"doc":"","ref":"MinizincData.html#t:data_chunk/0","title":"MinizincData.data_chunk/0","type":"type"},{"doc":"","ref":"MinizincData.html#t:mzn_data/0","title":"MinizincData.mzn_data/0","type":"type"},{"doc":"Functions to construct and access Minizinc model.","ref":"MinizincModel.html","title":"MinizincModel","type":"module"},{"doc":"","ref":"MinizincModel.html#make_model/2","title":"MinizincModel.make_model/2","type":"function"},{"doc":"","ref":"MinizincModel.html#model_method/1","title":"MinizincModel.model_method/1","type":"function"},{"doc":"","ref":"MinizincModel.html#t:model_chunk/0","title":"MinizincModel.model_chunk/0","type":"type"},{"doc":"","ref":"MinizincModel.html#t:mzn_model/0","title":"MinizincModel.mzn_model/0","type":"type"},{"doc":"Functions for parsing a stream of text produced by Minizinc process.","ref":"MinizincParser.html","title":"MinizincParser","type":"module"},{"doc":"","ref":"MinizincParser.html#parse_output/1","title":"MinizincParser.parse_output/1","type":"function"},{"doc":"Port server for Minizinc solver executable.","ref":"MinizincPort.html","title":"MinizincPort","type":"module"},{"doc":"Returns a specification to start this module under a supervisor.See Supervisor.","ref":"MinizincPort.html#child_spec/1","title":"MinizincPort.child_spec/1","type":"function"},{"doc":"","ref":"MinizincPort.html#get_results/1","title":"MinizincPort.get_results/1","type":"function"},{"doc":"","ref":"MinizincPort.html#get_results_and_stop/1","title":"MinizincPort.get_results_and_stop/1","type":"function"},{"doc":"Callback implementation for GenServer.init/1.","ref":"MinizincPort.html#init/1","title":"MinizincPort.init/1","type":"function"},{"doc":"","ref":"MinizincPort.html#start_link/2","title":"MinizincPort.start_link/2","type":"function"},{"doc":"Functions and data structures for working with data produced by Minizinc during runtime.","ref":"MinizincResults.html","title":"MinizincResults","type":"module"},{"doc":"","ref":"MinizincResults.html#get_status/1","title":"MinizincResults.get_status/1","type":"function"},{"doc":"","ref":"MinizincResults.html#results_rec/1","title":"MinizincResults.results_rec/1","type":"macro"},{"doc":"","ref":"MinizincResults.html#results_rec/2","title":"MinizincResults.results_rec/2","type":"macro"},{"doc":"Update solver process results with the line produced by Minizinc port.","ref":"MinizincResults.html#update_results/2","title":"MinizincResults.update_results/2","type":"function"},{"doc":"","ref":"MinizincResults.html#update_status/2","title":"MinizincResults.update_status/2","type":"function"},{"doc":"Minizinc solver API.","ref":"MinizincSolver.html","title":"MinizincSolver","type":"module"},{"doc":"Default solver arguments.","ref":"MinizincSolver.html#default_args/0","title":"MinizincSolver.default_args/0","type":"function"},{"doc":"Default solution handler for solve/2,3","ref":"MinizincSolver.html#default_async_handler/2","title":"MinizincSolver.default_async_handler/2","type":"function"},{"doc":"Default solution handler for solve_sync/2,3","ref":"MinizincSolver.html#default_sync_handler/2","title":"MinizincSolver.default_sync_handler/2","type":"function"},{"doc":"Default Minizinc executable.","ref":"MinizincSolver.html#get_executable/0","title":"MinizincSolver.get_executable/0","type":"function"},{"doc":"Get list of solver ids for solvers available to Minizinc.","ref":"MinizincSolver.html#get_solverids/0","title":"MinizincSolver.get_solverids/0","type":"function"},{"doc":"Get list of descriptions for solvers available to Minizinc.","ref":"MinizincSolver.html#get_solvers/0","title":"MinizincSolver.get_solvers/0","type":"function"},{"doc":"Lookup a solver by (possibly partial) id; for results, it could be 'cplex' or 'org.minizinc.mip.cplex'","ref":"MinizincSolver.html#lookup/1","title":"MinizincSolver.lookup/1","type":"function"},{"doc":"Shortcut for solve/2.","ref":"MinizincSolver.html#solve/1","title":"MinizincSolver.solve/1","type":"function"},{"doc":"Solve (asynchronously) with model, data and options.Example:# Solve Sudoku puzzle with &quot;mzn/sudoku.mzn&quot; model, &quot;mzn/sudoku.dzn&quot; data, # and custom solution handler Sudoku.solution_handler/2. # MinizincSolver.solve(&quot;mzn/sudoku.mzn&quot;, &quot;mzn/sudoku.dzn&quot;, [solution_handler: &amp;Sudoku.solution_handler/2]) Check out Sudoku module in examples/sudoku.ex for more details on handling solutions.","ref":"MinizincSolver.html#solve/3","title":"MinizincSolver.solve/3","type":"function"},{"doc":"Shortcut for solve_sync/2.","ref":"MinizincSolver.html#solve_sync/1","title":"MinizincSolver.solve_sync/1","type":"function"},{"doc":"Solve (synchronously) with model, data and options.Example:# Solve N-queens puzzle with n = 4. # Use Gecode solver, solve within 1000 ms. # results = MinizincSolver.solve_sync(&quot;mzn/nqueens.mzn&quot;, %{n: 4}, [solver: &quot;gecode&quot;, time_limit: 1000]) Check out NQueens module in examples/nqueens.ex for more details on handling solutions.","ref":"MinizincSolver.html#solve_sync/3","title":"MinizincSolver.solve_sync/3","type":"function"},{"doc":"Stop solver process.","ref":"MinizincSolver.html#stop_solver/1","title":"MinizincSolver.stop_solver/1","type":"function"},{"doc":"","ref":"MinizincSolver.html#t:solver_opt/0","title":"MinizincSolver.solver_opt/0","type":"type"},{"doc":"","ref":"MinizincSolver.html#t:solver_opts/0","title":"MinizincSolver.solver_opts/0","type":"type"},{"doc":"Helpers","ref":"MinizincUtils.html","title":"MinizincUtils","type":"module"},{"doc":"Example: N-queens solver.","ref":"NQueens.html","title":"NQueens","type":"module"},{"doc":"","ref":"NQueens.html#print_board/1","title":"NQueens.print_board/1","type":"function"},{"doc":"","ref":"NQueens.html#solution_handler/2","title":"NQueens.solution_handler/2","type":"function"},{"doc":"","ref":"NQueens.html#solve/2","title":"NQueens.solve/2","type":"function"},{"doc":"","ref":"NQueens.html#solve_sync/2","title":"NQueens.solve_sync/2","type":"function"},{"doc":"Documentation for Solverl.","ref":"Solverl.html","title":"Solverl","type":"module"},{"doc":"Example: Sudoku solver.","ref":"Sudoku.html","title":"Sudoku","type":"module"},{"doc":"","ref":"Sudoku.html#print_grid/1","title":"Sudoku.print_grid/1","type":"function"},{"doc":"","ref":"Sudoku.html#solve/2","title":"Sudoku.solve/2","type":"function"},{"doc":"","ref":"Sudoku.html#solve_sync/1","title":"Sudoku.solve_sync/1","type":"function"},{"doc":"","ref":"Sudoku.html#sudoku_samples/0","title":"Sudoku.sudoku_samples/0","type":"function"},{"doc":"SolverlErlang/Elixir interface to Minizinc.","ref":"readme.html","title":"Solverl","type":"extras"},{"doc":"Installation of Minizinc is required on your system. Please refer to https://www.minizinc.org/software.html for details.The package can be installed by adding solverl to your list of dependencies in mix.exs:def deps do [ {:solverl, &quot;~&gt; 0.1.0&quot;} ] endThe docs can be found at https://hexdocs.pm/solverl.","ref":"readme.html#installation","title":"Solverl - Installation","type":"extras"},{"doc":"The following code uses Minizinc model mzn/nqueens.mzn to solve N-queens puzzle for N = 4: MinizincSolver.solve(&quot;mzn/nqueens.mzn&quot;, %{n: 4}, [solution_handler: &amp;NQueens.solution_handler/2]) Output: iex(4)&gt; 23:30:21.094 [warn] Command: /Applications/MiniZincIDE.app/Contents/Resources/minizinc --allow-multiple-assignments --output-mode json --output-time --output-objective --output-output-item -s -a --solver org.gecode.gecode --time-limit 300000 /var/folders/rn/_39sx1c12ws1x5k66n_cjjh00000gn/T/tmp.7NABDxEp.mzn /var/folders/rn/_39sx1c12ws1x5k66n_cjjh00000gn/T/tmp.JEV4UXP5.dzn {:ok, #PID&lt;0.2115.0&gt;} iex(73)&gt; 23:30:21.216 [info] . . ♕ . ♕ . . . . . . ♕ . ♕ . . ----------------------- 23:30:21.216 [info] . ♕ . . . . . ♕ ♕ . . . . . ♕ . ----------------------- 23:30:21.221 [info] Solution status: ALL_SOLUTIONS 23:30:21.221 [info] Solver stats: %{&quot;failures&quot; =&gt; &quot;4&quot;, &quot;initTime&quot; =&gt; &quot;0.010053&quot;, &quot;nSolutions&quot; =&gt; &quot;2&quot;, &quot;nodes&quot; =&gt; &quot;11&quot;, &quot;peakDepth&quot; =&gt; &quot;2&quot;, &quot;propagations&quot; =&gt; &quot;163&quot;, &quot;propagators&quot; =&gt; &quot;11&quot;, &quot;restarts&quot; =&gt; &quot;0&quot;, &quot;solutions&quot; =&gt; &quot;2&quot;, &quot;solveTime&quot; =&gt; &quot;0.002834&quot;, &quot;variables&quot; =&gt; &quot;12&quot;} 23:30:21.221 [debug] ** TERMINATE: :normal","ref":"readme.html#n-queens-example","title":"Solverl - N-Queens example","type":"extras"},{"doc":"## Asynchronously solve Sudoku puzzle, using the solution handler Sudoku.solution_handler/2: ## (the source code for Sudoku module is examples/sudoku.ex) Sudoku.solve(&quot;85...24..72......9..4.........1.7..23.5...9...4...........8..7..17..........36.4.&quot;)The output:23:54:34.018 [info] Sudoku puzzle: 23:54:34.018 [info] +-------+-------+-------+ | 8 5 . | . . 2 | 4 . . | | 7 2 . | . . . | . . 9 | | . . 4 | . . . | . . . | +-------+-------+-------+ | . . . | 1 . 7 | . . 2 | | 3 . 5 | . . . | 9 . . | | . 4 . | . . . | . . . | +-------+-------+-------+ | . . . | . 8 . | . 7 . | | . 1 7 | . . . | . . . | | . . . | . 3 6 | . 4 . | +-------+-------+-------+ 23:54:34.067 [warn] Command: /Applications/MiniZincIDE.app/Contents/Resources/minizinc --allow-multiple-assignments --output-mode json --output-time --output-objective --output-output-item -s -a --solver org.gecode.gecode --time-limit 300000 /var/folders/rn/_39sx1c12ws1x5k66n_cjjh00000gn/T/tmp.ntx0ThIr.mzn /var/folders/rn/_39sx1c12ws1x5k66n_cjjh00000gn/T/tmp.yUorqedH.dzn {:ok, #PID&lt;0.2146.0&gt;} iex(79)&gt; 23:54:34.124 [info] +-------+-------+-------+ | 8 5 9 | 6 1 2 | 4 3 7 | | 7 2 3 | 8 5 4 | 1 6 9 | | 1 6 4 | 3 7 9 | 5 2 8 | +-------+-------+-------+ | 9 8 6 | 1 4 7 | 3 5 2 | | 3 7 5 | 2 6 8 | 9 1 4 | | 2 4 1 | 5 9 3 | 7 8 6 | +-------+-------+-------+ | 4 3 2 | 9 8 1 | 6 7 5 | | 6 1 7 | 4 2 5 | 8 9 3 | | 5 9 8 | 7 3 6 | 2 4 1 | +-------+-------+-------+ 23:54:34.124 [info] Solutions found: 1 23:54:34.129 [info] Solver stats: %{&quot;failures&quot; =&gt; &quot;11&quot;, &quot;initTime&quot; =&gt; &quot;0.000879&quot;, &quot;nSolutions&quot; =&gt; &quot;1&quot;, &quot;nodes&quot; =&gt; &quot;23&quot;, &quot;peakDepth&quot; =&gt; &quot;5&quot;, &quot;propagations&quot; =&gt; &quot;685&quot;, &quot;propagators&quot; =&gt; &quot;27&quot;, &quot;restarts&quot; =&gt; &quot;0&quot;, &quot;solutions&quot; =&gt; &quot;1&quot;, &quot;solveTime&quot; =&gt; &quot;0.000605&quot;, &quot;variables&quot; =&gt; &quot;147&quot;} 23:54:34.129 [debug] ** TERMINATE: :normal","ref":"readme.html#sudoku-example","title":"Solverl - Sudoku example","type":"extras"},{"doc":"# Asynchronous solving. # Creates a solver process. # Handling of solutions is done by the pluggable solution handler (explained in Configuration section). {:ok, solver_pid} = Minizinc.solve(model, data, opts) # Synchronous solving. # Starts the solver and gets the results (solutions and/or solver stats) once the solver finishes. # The solution handler can customize the results, such as format/filter/limit the number of solutions, conditionally interrupt solver process etc. solver_results = Minizinc.solve_sync(model, data, opts) , where model is a specification of the Minizinc model, data - specification of data passed to model, opts - various solver options, such as solver id, time limit, compilation flags, solution handler.","ref":"readme.html#usage","title":"Solverl - Usage","type":"extras"},{"doc":"TODO","ref":"readme.html#solver-options","title":"Solverl - Solver options","type":"extras"},{"doc":"TODO","ref":"readme.html#solution-handlers","title":"Solverl - Solution handlers","type":"extras"},{"doc":"TODO: Support LNS Support Branch-and-Bound","ref":"readme.html#roadmap","title":"Solverl - Roadmap","type":"extras"}]